<?php
//
// +----------------------------------------------------------------------+
// | PHP Multi-Byte String Functions                                      |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003-2004 Hayk Chamyan <hayk@mail.ru>                  |
// +----------------------------------------------------------------------+
// | License: http://www.gnu.org/licenses/gpl.txt                         |
// +----------------------------------------------------------------------+
//
// $Header: mbm.lib.php, 11, 21.04.2004 14:37:36, Hayk Chamyan$
//

	/**
	 *      - mb_
	 */

	define('MB_ASCII_SP', chr(32));

	/**
	 *
	 */
	//function mb_str_replace($search, $replace, $subject, &$count)
	function mb_str_replace($search, $replace, $subject, $encoding=MB_UTF8)
	{
		//     UTF-8    -
		//    UTF-8   .
		return str_replace($search, $replace, $subject);
	} //end function mb_str_replace

	/**
	 * mb_ucwords --  Uppercase the first character of each word in a string
	 * $str - String
	 * return - String
	 */
	function mb_ucwords($str, $encoding=MB_UTF8)
	{
		$space = mb_convert_encoding(MB_ASCII_SP, $encoding, MB_ASCII);
		$words = explode($space, $str);
		for ($i=0; $i<count($words); $i++)
		{
			$words[$i] = mb_ucfirst($words[$i], $encoding);
		}
		return implode($space, $words);
	} //end function mb_ucwords

	/**
	 * mb_ucfirst -- Make a string's first character uppercase
	 *      .      
	 * $str - String
	 * return - String
	 */
	function mb_ucfirst($str, $encoding=MB_UTF8)
	{
		return mb_strtoupper(mb_substr($str, 0, 1, $encoding), $encoding) . mb_substr($str, 1, mb_strlen($str, $encoding)-1, $encoding);
	} //end function mb_ucfirst

	/**
	 * mb_strstr -- Find first occurrence of a string
	 *
	 */
	function mb_strstr($haystack, $needle, $encoding=MB_UTF8)
	{
		if ( ($start = mb_strpos($haystack, $needle, NULL, $encoding)) !== FALSE )
		{
			return (mb_substr($haystack, $start, mb_strlen($haystack, $encoding), $encoding));
		}
		else
		{
			return FALSE;
		}
	} //end function mb_strstr

	/**
	 * strtr -- Translate certain characters
	 *
	 *
	 * string strtr ( string str, string from, string to) -  
	 *    utf8
	 *  -        
	 * function mb_strtr($str, $from, $to=NULL, $encoding=MB_UTF8)
	 * function mb_strtr($str, $replace_pairs, $encoding=MB_UTF8)
	 */
	function mb_strtr($str, $from, $to=NULL, $encoding=MB_UTF8)
	{
		if ( is_array($from) )
		{
			return strtr($str, $from);
		}
		else
		{
			return strtr($str, $from, $to);
		}
	} //end function mb_strtr

	/**
	 * Can be used to split a string into smaller chunks which is useful for e.g.
	 * converting base64_encode output to match RFC 2045 semantics. It inserts end
	 * (defaults to "\r\n") every chunklen characters (defaults to 76). It returns
	 * the new string leaving the original string untouched.
	 */
	function mb_chunk_split($body, $chunklen=NULL, $end=NULL, $encoding=MB_UTF8)
	{
		return chunk_split($body, $chunklen, $end);
	} //end function mb_chunk_split

	/**
	 *
	 */
	function mb_strip_tags($str, $allowable_tags=NULL, $encoding=MB_UTF8)
	{
		return strip_tags($str, $allowable_tags);
	} //end function mb_strip_tags

	/**
	 *
	 */
	function mb_stristr($haystack, $needle, $encoding=MB_UTF8)
	{
		//      
		//   strstr();       ,   
		$o_haystack = $haystack;
		$haystack = mb_strtolower($haystack, $encoding);
		$needle   = mb_strtolower($needle, $encoding);
		$start = mb_strpos($haystack, $needle, NULL, $encoding);
		return ($start!==FALSE) ? mb_substr($o_haystack, $start, mb_strlen($haystack, $encoding), $encoding) : FALSE;
	} //end function mb_stristr

	define('MBM_LIB_INCLUDED', 'mbm.lib.php');

	/**
	 * function template
	 */
	//function mb_()
	//{
	//	return;
	//} //end function mb_

?>