<?php
//
// +----------------------------------------------------------------------+
// | PHP Multi-Byte String Functions                                      |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003-2004 Hayk Chamyan <hayk@mail.ru>                  |
// +----------------------------------------------------------------------+
// | License: http://www.gnu.org/licenses/gpl.txt                         |
// +----------------------------------------------------------------------+
//
// $Header: mbs.lib.php, 14, 01.04.2004 16:39:07, Hayk Chamyan$
//

	/**
	 * array for global data
	 */
	$mbs_data = array
	(
		'mb_language' => 'uni',
		'mb_regex_encoding' => MB_UTF8,
		'mb_internal_encoding' => MB_UTF8
	);

	/**
	 * mb_strlen -- Get string length
	 */
	function mb_strlen($str, $encoding=MB_UTF8)
	{
		$str = mb_convert_encoding($str, MB_UCS2LE, $encoding);
		return us_strlen( $str );
	} // end function mb_strlen

	/**
	 * mb_send_mail --  Send encoded mail.
	 */
	function mb_send_mail($to, $subject, $message, $additional_headers=NULL, $additional_parameter=NULL, $encoding=MB_UTF8)
	{
		$utf8_header = "MIME-Version: 1.0\nContent-type: text/plain; charset=UTF-8\nContent-transfer-encoding: BASE64\n";

		$subject = mb_convert_encoding($subject, MB_UTF8, $encoding);
		$message = mb_convert_encoding($message, MB_UTF8, $encoding);

		if ($additional_headers)
		{
			$additional_headers .= $utf8_header;
		}
		else
		{
			$additional_headers = $utf8_header;
		}

		$subject = mb_encode_mimeheader($subject);
		$message = chunk_split(base64_encode($message));
		return mail($to, $subject, $message, $additional_headers, $additional_parameter);
	} // end function mb_send_mail

	/**
	 * Encode string for MIME header
	 * доделать: $charset, $transfer_encoding, $linefeed
	 * навреное стоит сперва все засовывать в массиы, а потом делать этому implode()
	 */
	function mb_encode_mimeheader($string, $charset=MB_UTF8, $transfer_encoding='B', $linefeed="\r\n")
	{
		$fplen = 42;
		$cplen = 47;

		$prefix = '=?UTF-8?B?';
		$postfix = '?=';
		//$newline = "\n ";
		$newline = "\r\n ";
		$mime_string = '';

		$ppos = 0;
		$plen = $fplen;

		while ( $part = substr($string, $ppos, $plen) )
		{
			$mime_string .= $prefix.base64_encode($part).$postfix.$newline;
			$ppos += $plen;
			$plen = $cplen;
		}

		$mime_string = substr($mime_string, 0, strlen($mime_string)-strlen($newline) );
		return $mime_string;
	} // end function mb_encode_mimeheader

	/**
	 * mb_strpos --  Find position of first occurrence of string in a string
	 */
	function mb_strpos($haystack, $needle , $offset=NULL, $encoding=MB_UTF8)
	{
		$haystack = mb_convert_encoding($haystack, MB_UCS2LE, $encoding);
		$needle   = mb_convert_encoding($needle, MB_UCS2LE, $encoding);
		return us_strpos($haystack, $needle, $offset);
	} //end function mb_strpos

	/**
	 * mb_strrpos --  Find position of last occurrence of a string in a string
	 */
	function mb_strrpos($haystack, $needle, $encoding=MB_UTF8)
	{
		$haystack = mb_convert_encoding($haystack, MB_UCS2LE, $encoding);
		$needle   = mb_convert_encoding($needle, MB_UCS2LE, $encoding);
		return us_strrpos($haystack, $needle);
	} //end function mb_strrpos

	/**
	 * mb_substr -- Get part of string
	 */
	function mb_substr($str, $start, $length=NULL, $encoding=MB_UTF8)
	{
		$str = mb_convert_encoding($str, MB_UCS2LE, $encoding);
		$str = us_substr($str, $start, $length);
		$str = mb_convert_encoding($str, $encoding, MB_UCS2LE);
		return $str;
	} //end function mb_substr

	/**
	 * mb_strtolower -- Make a string lowercase
	 */
	function mb_strtolower($str, $encoding=MB_UTF8)
	{
		$str = mb_convert_encoding($str, MB_UCS2LE, $encoding);
		$str = us_strtolower($str);
		$str = mb_convert_encoding($str, $encoding, MB_UCS2LE);
		return $str;
	} //end function mb_strtolower


	/**
	 * mb_strtoupper -- Make a string uppercase
	 */
	function mb_strtoupper($str, $encoding=MB_UTF8)
	{
		$str = mb_convert_encoding($str, MB_UCS2LE, $encoding);
		$str = us_strtoupper($str);
		$str = mb_convert_encoding($str, $encoding, MB_UCS2LE);
		return $str;
	} //end function mb_strtoupper

	/**
	 * mb_substr_count -- Count the number of substring occurrences
	 */
	function mb_substr_count($haystack, $needle, $encoding=MB_UTF8)
	{
		$haystack = mb_convert_encoding($haystack, MB_UCS2LE, $encoding);
		$needle   = mb_convert_encoding($needle, MB_UCS2LE, $encoding);
		return us_substr_count($haystack, $needle);
	} //end function mb_substr_count

	/**
	 * mb_convert_encoding -- Convert character encoding
	 * MB_ASCII
	 * MB_UCS2LE = MB_UCS2
	 * MB_UCS2BE
	 * MB_UTF8
	 * MB_ARMSCII8
	 *
	 */
	function mb_convert_encoding($str, $to_encoding, $from_encoding)
	{
		if ($to_encoding == $from_encoding)
		{
			return $str;
		}
		if ( ($from_encoding!=MB_UCS2LE) && ($from_encoding!=MB_UCS2) )
		{
			$str = us_to_unicode($str, $from_encoding);
		}
		if ( ($to_encoding!=MB_UCS2LE) && ($to_encoding!=MB_UCS2) )
		{
			$str = us_from_unicode($str, $to_encoding);
		}
		return $str;
	} //end function mb_convert_encoding

	/**
	 * mb_convert_case() returns case folded version of string converted in the way specified by mode.
	 * mode can be one of MB_CASE_UPPER, MB_CASE_LOWER or MB_CASE_TITLE.
	 */
	function mb_convert_case($str, $mode, $encoding=MB_UTF8)
	{
		return $str;
	} //end function mb_convert_case

	////////////////////////////////////////////////////////////////////////
	//
	// stubs section (for compatibility only)
	// please use preg_* functions
	//
	// ereg()			mb_ereg()			preg_match()
	// eregi()			mb_eregi()			preg_match()
	// ereg_replace()	mb_ereg_replace()	preg_replace()
	// eregi_replace()	mb_eregi_replace()	preg_replace()
	// split()			mb_split()			preg_split()
	//
	////////////////////////////////////////////////////////////////////////

	/**
	 * mb_ereg -- Regular expression match with multibyte support
	 * что делать с третьим аргументом?
	 */
	function mb_ereg($pattern, $string, &$regs)
	{
		return ereg($pattern, $string, $regs);
	} //end function mb_ereg

	/**
	 * mb_eregi --  Regular expression match ignoring case with multibyte support
	 * что делать с третьим аргументом?
	 */
	function mb_eregi($pattern, $string, &$regs)
	{
		return eregi($pattern, $string, $regs);
	} //end function mb_eregi

	/**
	 * mb_ereg_replace -- Replace regular expression with multibyte support
	 */
	function mb_ereg_replace($pattern, $replacement, $string, $option=NULL)
	{
		return ereg_replace($pattern, $replacement, $string);
	} //end function mb_ereg_replace

	/**
	 * mb_eregi_replace --  Replace regular expression with multibyte support ignoring case
	 */
	function mb_eregi_replace($pattern, $replace, $string)
	{
		return eregi_replace($pattern, $replace, $string);
	} //end function mb_eregi_replace

	/**
	 * mb_split -- Split multibyte string using regular expression
	 * похоже надо реализовать mb_regex_encoding()
	 *
	 */
	function mb_split($pattern, $string, $limit=NULL)
	{
		if ($limit)
		{
			$result = split($pattern, $string, $limit);
		}
		else
		{
			$result = split($pattern, $string);
		}
		return $result;
	} //end function mb_split

	/**
	 *
	 * Valid languages are "Japanese", "ja","English","en" and "uni" (UTF-8)
	 * mb_send_mail() uses this setting to encode e-mail.
	 */
	function mb_language($language=NULL)
	{
		global $mbs_data;
		$result = FALSE;
		if ($language)
		{
			$mbs_data['mb_language'] = $language;
			$result = TRUE;
		}
		else
		{
			$result = $mbs_data['mb_language'];
		}
		return $result;
	} //end function mb_language

	/**
	 *
	 *
	 */
	function mb_regex_encoding($encoding)
	{
		global $mbs_data;
		$mbs_data['mb_regex_encoding'] = $encoding;
	} //end function mb_regex_encoding

	/**
	 *
	 *
	 */
	function mb_internal_encoding($encoding)
	{
		global $mbs_data;
		$mbs_data['mb_internal_encoding'] = $encoding;
	} //end function mb_internal_encoding

	define('MBS_LIB_INCLUDED', 'mbs.lib.php');

	//mb_language('uni'); - for mb_send_mail
	//mb_regex_encoding('UTF-8'); - for ereg_* functions
	//mb_internal_encoding('UTF-8'); - for functions

	/**
	 * mb_convert_case -- Perform case folding on a string
	 * mb_convert_kana --  Convert "kana" one from another ("zen-kaku" ,"han-kaku" and more)
	 * mb_convert_variables -- Convert character code in variable(s)
	 * mb_decode_mimeheader -- Decode string in MIME header field
	 * mb_decode_numericentity --  Decode HTML numeric string reference to character
	 * mb_detect_encoding -- Detect character encoding
	 * mb_detect_order --  Set/Get character encoding detection order
	 * mb_encode_mimeheader -- Encode string for MIME header
	 * mb_encode_numericentity --  Encode character to HTML numeric string reference
	 * mb_ereg_match --  Regular expression match for multibyte string
	 * mb_ereg_search_getpos --  Returns start point for next regular expression match
	 * mb_ereg_search_getregs --  Retrieve the result from the last multibyte regular expression match
	 * mb_ereg_search_init --  Setup string and regular expression for multibyte regular expression match
	 * mb_ereg_search_pos --  Return position and length of matched part of multibyte regular expression for predefined multibyte string
	 * mb_ereg_search_regs --  Returns the matched part of multibyte regular expression
	 * mb_ereg_search_setpos --  Set start point of next regular expression match
	 * mb_ereg_search --  Multibyte regular expression match for predefined multibyte string

	 * mb_get_info -- Get internal settings of mbstring
	 * mb_http_input -- Detect HTTP input character encoding
	 * mb_http_output -- Set/Get HTTP output character encoding
	 * mb_internal_encoding --  Set/Get internal character encoding
	 * mb_language --  Set/Get current language
	 * mb_output_handler --  Callback function converts character encoding in output buffer
	 * mb_parse_str --  Parse GET/POST/COOKIE data and set global variable
	 * mb_preferred_mime_name -- Get MIME charset string
	 * mb_regex_encoding --  Returns current encoding for multibyte regex as string
	 * mb_regex_set_options --  Set/Get the default options for mbregex functions
	 * mb_strcut -- Get part of string
	 * mb_strimwidth -- Get truncated string with specified width
	 * mb_strtoupper -- Make a string uppercase
	 * mb_strwidth -- Return width of string
	 * mb_substitute_character -- Set/Get substitution character
	 */

?>