<?php
//
// +----------------------------------------------------------------------+
// | PHP Multi-Byte String Functions                                      |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003-2004 Hayk Chamyan <hayk@mail.ru>                  |
// | Copyright (c) 1997-2003 The PHP Group                                |
// +----------------------------------------------------------------------+
// | License: http://www.gnu.org/licenses/gpl.txt                         |
// +----------------------------------------------------------------------+
//
// $Header: uni.lib.php, 11, 10.03.2004 18:34:49, Hayk Chamyan$
//

	require_once (MBS_DIR . '/uni.data.php');

	//  define  ?

	/*
	 * Values that can appear in the `mask1' parameter of the php_unicode_is_prop()
	 * function.
	 */
	define('UC_MN', 0x00000001); /* Mark, Non-Spacing          */
	define('UC_MC', 0x00000002); /* Mark, Spacing Combining    */
	define('UC_ME', 0x00000004); /* Mark, Enclosing            */
	define('UC_ND', 0x00000008); /* Number, Decimal Digit      */
	define('UC_NL', 0x00000010); /* Number, Letter             */
	define('UC_NO', 0x00000020); /* Number, Other              */
	define('UC_ZS', 0x00000040); /* Separator, Space           */
	define('UC_ZL', 0x00000080); /* Separator, Line            */
	define('UC_ZP', 0x00000100); /* Separator, Paragraph       */
	define('UC_CC', 0x00000200); /* Other, Control             */
	define('UC_CF', 0x00000400); /* Other, Format              */
	define('UC_OS', 0x00000800); /* Other, Surrogate           */
	define('UC_CO', 0x00001000); /* Other, Private Use         */
	define('UC_CN', 0x00002000); /* Other, Not Assigned        */
	define('UC_LU', 0x00004000); /* Letter, Uppercase          */
	define('UC_LL', 0x00008000); /* Letter, Lowercase          */
	define('UC_LT', 0x00010000); /* Letter, Titlecase          */
	define('UC_LM', 0x00020000); /* Letter, Modifier           */
	define('UC_LO', 0x00040000); /* Letter, Other              */
	define('UC_PC', 0x00080000); /* Punctuation, Connector     */
	define('UC_PD', 0x00100000); /* Punctuation, Dash          */
	define('UC_PS', 0x00200000); /* Punctuation, Open          */
	define('UC_PE', 0x00400000); /* Punctuation, Close         */
	define('UC_PO', 0x00800000); /* Punctuation, Other         */
	define('UC_SM', 0x01000000); /* Symbol, Math               */
	define('UC_SC', 0x02000000); /* Symbol, Currency           */
	define('UC_SK', 0x04000000); /* Symbol, Modifier           */
	define('UC_SO', 0x08000000); /* Symbol, Other              */
	define('UC_L',  0x10000000); /* Left-To-Right              */
	define('UC_R',  0x20000000); /* Right-To-Left              */
	define('UC_EN', 0x40000000); /* European Number            */
	define('UC_ES', 0x80000000); /* European Number Separator  */

	/*
	 * Values that can appear in the `mask2' parameter of the php_unicode_is_prop()
	 * function.
	 */
	define('UC_ET', 0x00000001); /* European Number Terminator */
	define('UC_AN', 0x00000002); /* Arabic Number              */
	define('UC_CS', 0x00000004); /* Common Number Separator    */
	define('UC_B',  0x00000008); /* Block Separator            */
	define('UC_S',  0x00000010); /* Segment Separator          */
	define('UC_WS', 0x00000020); /* Whitespace                 */
	define('UC_ON', 0x00000040); /* Other Neutrals             */
	/*
	 * Implementation specific character properties.
	 */
	define('UC_CM', 0x00000080); /* Composite                  */
	define('UC_NB', 0x00000100); /* Non-Breaking               */
	define('UC_SY', 0x00000200); /* Symmetric                  */
	define('UC_HD', 0x00000400); /* Hex Digit                  */
	define('UC_QM', 0x00000800); /* Quote Mark                 */
	define('UC_MR', 0x00001000); /* Mirroring                  */
	define('UC_SS', 0x00002000); /* Space, other               */
	define('UC_CP', 0x00004000); /* Defined                    */

	/*
	 * Added for UnicodeData-2.1.3.
	 */
	define('UC_PI', 0x00008000); /* Punctuation, Initial       */
	define('UC_PF', 0x00010000); /* Punctuation, Final         */

	$masks32 = array
	(
	    0x00000001, 0x00000002, 0x00000004, 0x00000008, 0x00000010, 0x00000020,
	    0x00000040, 0x00000080, 0x00000100, 0x00000200, 0x00000400, 0x00000800,
	    0x00001000, 0x00002000, 0x00004000, 0x00008000, 0x00010000, 0x00020000,
	    0x00040000, 0x00080000, 0x00100000, 0x00200000, 0x00400000, 0x00800000,
	    0x01000000, 0x02000000, 0x04000000, 0x08000000, 0x10000000, 0x20000000,
	    0x40000000, 0x80000000
	);

	define('MB_ASCII',		'ASCII');	//  
	define('MB_UCS2',		'UCS-2');	//  
	define('MB_UCS2LE',		'UCS-2LE');	//  
	define('MB_UCS2BE',		'UCS-2BE'); //  
	define('MB_UTF8',		'UTF-8');
	define('MB_ARMSCII8',	'ARMSCII-8');
	define('MB_HTML',		'HTML');
	define('MB_HTML_ENTITIES',	'HTML-ENTITIES');

	//define('ASCII',		'ASCII');	//  
	//define('UCS2',		'UCS-2');	//  
	//define('UCS2LE',	'UCS-2LE');	//  
	//define('UCS2BE',	'UCS-2BE'); //  
	//define('UTF8',		'UTF-8');
	//define('ARMSCII8',	'ARMSCII-8');

	/**
	 *
	 * function from MB String module
	 *
	 * $code - integet [string - auei] / 2b unicode char
	 * $l - integer
	 * $l - integer
	 * $field - integer
	 * return integer
	 */
	function case_lookup($code, $l, $r, $field)
	{
		global $_uccase_map;

		$m = 0;

		while ($l <= $r)
		{
			/*
			 * Determine a "mid" point and adjust to make sure the mid point is at
			 * the beginning of a case mapping triple.
			 */
			$m = ($l + $r) >> 1;
			$m -= ($m % 3);
			if ( $code > $_uccase_map[$m] )
			{
				$l = $m + 3;
			}
			elseif ( $code < $_uccase_map[$m] )
			{
				$r = $m - 3;
			}
			elseif ( $code == $_uccase_map[$m] )
			{
				return $_uccase_map[$m + $field];
			}
		}
		return $code;
	} // end function case_lookup

	/**
	 *
	 *  0  1  true  false
	 */
	function prop_lookup($code, $n)
	{
		global $_ucprop_offsets;
		global $_ucprop_size;
		global $_ucprop_ranges;
		$l = 0;
		$r = 0;
		$m = 0;

		/*
		 * There is an extra node on the end of the offsets to allow this routine
		 * to work right.  If the index is 0xffff, then there are no nodes for the
		 * property.
		 */
		if (($l = $_ucprop_offsets[$n]) == 0xFFFF)
		return 0;

		/*
		 * Locate the next offset that is not 0xffff.  The sentinel at the end of
		 * the array is the max index value.
		 */
		for ($m = 1; $n + $m < $_ucprop_size && $_ucprop_offsets[$n + $m] == 0xFFFF; $m++)
		;

		$r = $_ucprop_offsets[$n + $m] - 1;

		while ($l <= $r)
		{
			/*
			 * Determine a "mid" point and adjust to make sure the mid point is at
			 * the beginning of a range pair.
			 */
			$m = ($l + $r) >> 1;
			$m -= ($m & 1);
			if ( $code > $_ucprop_ranges[$m + 1] )
			{
				$l = $m + 2;
			}
			elseif ( $code < $_ucprop_ranges[$m] )
			{
				$r = $m - 2;
			}
			elseif ( $code >= $_ucprop_ranges[$m] && $code <= $_ucprop_ranges[$m + 1] )
			{
				return TRUE;
			}
		}
		return FALSE;
	} // end function prop_lookup

	/**
	 *
	 *
	 */
	function uni_is_prop($code, $mask1, $mask2)
	{
		global $masks32;
		global $_ucprop_size;

		if ( ($mask1 == 0) && ( $mask2 == 0) )
		{
			return FALSE;
		}

		for ($i = 0; $mask1 && $i < 32; $i++)
		{
			if ( ($mask1 & $masks32[$i]) && prop_lookup($code, $i) )
			{
				return TRUE;
			}
		}

		for ($i = 32; $mask2 && $i < $_ucprop_size; $i++)
		{
			if ( ($mask2 & $masks32[$i & 31]) && prop_lookup($code, $i) )
			{
				return TRUE;
			}
		}

		return FALSE;
	} // end function uni_is_prop

	/**
	 *
	 */
	function uni_is_lower($code)
	{
		return uni_is_prop($code, UC_LL, 0);
	} // end function us_is_lower

	/**
	 *
	 */
	function uni_is_upper($code)
	{
		return uni_is_prop($code, UC_LU, 0);
	} // end function us_is_upper

	/**
	 * $code - integer
	 * return integer
	 */
	function uni_to_upper($code)
	{
		global $_uccase_len;
		global $_uccase_size;

		if ( uni_is_upper ($code) )
		{
			return $code;
		}

		if ( uni_is_lower($code) )
		{
			/*
			 * The character is lower case.
			 */
			$field = 2;
			$l = $_uccase_len[0];
			$r = ($l + $_uccase_len[1]) - 3;
		}
		else
		{
			/*
			 * The character is title case.
			 */
			$field = 1;
			$l = $_uccase_len[0] + $_uccase_len[1];
			$r = $_uccase_size - 3;
		}
		return case_lookup($code, $l, $r, $field);
	} // end function uni_to_upper


	/**
	 * $code - integer
	 * return integer
	 */
	function uni_to_lower($code)
	{
		global $_uccase_len;
		global $_uccase_size;

		if ( uni_is_lower($code) )
		{
			return $code;
		}

		if ( uni_is_upper($code) )
		{
			/*
			 * The character is upper case.
			 */
			$field = 1;
			$l = 0;
			$r = $_uccase_len[0] - 3;
		}
		else
		{
			/*
			 * The character is title case.
			 */
			$field = 2;
			$l = $_uccase_len[0] + $_uccase_len[1];
			$r = $_uccase_size - 3;
		}
		return case_lookup($code, $l, $r, $field);
		//return $code;
	} // end function uni_to_lower

	////////////////////////////////////////////////////////////////////////////
	//
	//
	////////////////////////////////////////////////////////////////////////////

	/**
	 * $str = ascii_2_ucs2le($str);
	 */
	function ascii_2_ucs2le($str)
	{
		/*$result = '';
		$strlen = strlen($str);

		for ($i = 0; $i < $strlen; $i++)
		{
			$result .= pack('v', ord($str{$i}));
		}*/

		/////////////////////////////////////////
		//   .
		// .. - unpack ,    1 
		//     

		$result = '';
		$len = strlen($str);
		$unpack = sprintf('C%dcode', $len);
		$data = unpack($unpack, $str);

		foreach ($data as $char)
		{
			$result .= pack('v', $char);
		}

		/////////////////////////////////////////

		/*$result = '';
		$len = strlen($str);
		$data = unpack('C'.$len, $str);
		for ($i=1; $i<=count($data); $i++)
		{
			$result .= pack('v', $data[$i]);
		}*/

		/////////////////////////////////////////

		return $result;
	} // end function ascii_2_ucs2le

	/**
	 * $str = ucs2be_2_ucs2le($str);
	 */
	function ucs2be_2_ucs2le($str)
	{
		$result = '';
		$len = us_strlen($str);

		/////////////////////////////////////////

		$unpack = sprintf('n%dcode', $len);
		$ucodes = unpack($unpack, $str);

		foreach ($ucodes as $code)
		{
			$result .= pack('v', $code);
		}

		/////////////////////////////////////////
		//      ,    1 
		//  PHP 4.3.4    .
		/*$ucodes = unpack('n'.$len, $str);

		for ($i=1; $i<=count($ucodes); $i++)
		{
			$result .= pack('v', $ucodes[$i]);
		}*/

		/////////////////////////////////////////

		return $result;
	} // end function ucs2be_2_ucs2le

	/**
	 *
	 * Convert UTF-8 string to Unicode LE
	 * $str = utf8_2_ucs2le($str);
	 */
	function utf8_2_ucs2le($utf8data)
	{

		$pos = 0;
		$ucs2data = '';

		for ($i = 0; $i < strlen( $utf8data ); $i++)
		{

			if ( $utf8data{$i} >= chr( 0xE0) )
			{
				$char = 0xFFFF & ( ( ( ord($utf8data{$i}) & 63 ) << 12 ) | ( ( ord($utf8data{$i+1}) & 63 ) << 6 ) | ( ord($utf8data{$i+2}) & 63 ) );
				$ucs2data .= pack('v', $char);
				$i++;
				$i++;
			}
			elseif ( $utf8data{$i} >= chr( 0xC0) )
			{
				$char = ( 0x0000 | ( ( ord( $utf8data{$i} ) & 63 ) << 6 ) | ( ord( $utf8data{$i+1} ) & 63 ) );
				$ucs2data .= pack('v', $char);;
				$i++;
			}
			else
			{
				$ucs2data .= $utf8data{$i} . pack('C', 0x00 );
			}

		}

		return $ucs2data;
	} // end function utf8_2_ucs2le

	/**
	 * $str = armscii8_2_ucs2le($str);
	 */
	function armscii8_2_ucs2le($str)
	{
		return armscii8_2_ucs2($str);
	} // end function armscii8_2_ucs2

	////////////////////////////////////////////////////////////////////////////
	//
	//
	////////////////////////////////////////////////////////////////////////////

	/**
	 * $str = ucs2le_2_ascii($str);
	 */
	function ucs2le_2_ascii($str)
	{
		// . -      
		//    0x00FF
		// ..      0x00FF   ? ( )
		$result = '';
		$len = us_strlen($str);
		$ucodes = unpack('v'.$len, $str);

		/////////////////////////////////////////

		foreach ($ucodes as $code)
		{
			$result .= pack('C', $code);
		}

		/////////////////////////////////////////
		//    foreach, ..  
		//       unpack
		//

		/*for ($i=1; $i<=count($ucodes); $i++)
		{
			$result .= pack('C', $ucodes[$i]);
		}*/

		/////////////////////////////////////////

		return $result;
	} // end function ucs2le_2_ascii

	/**
	 * ucs2le_2_ucs2be($str)
	 */
	function ucs2le_2_ucs2be($str)
	{
		$result = '';
		$len = us_strlen($str);

		/////////////////////////////////////////

		$ucodes = unpack('v'.$len, $str);
		foreach ($ucodes as $code)
		{
			$result .= pack('n', $code);
		}

		/////////////////////////////////////////

		/*$ucodes = unpack('v'.$len, $str);

		for ($i=1; $i<=count($ucodes); $i++)
		{
			$result .= pack('n', $ucodes[$i]);
		}*/

		/////////////////////////////////////////

		return $result;
	} // end function ucs2le_2_ucs2be

	/**
	 *
	 * Convert Unicode LE string to UTF-8 string
	 */
	function ucs2le_2_utf8($ucs2data)
	{

		$pos = 0;
		$utf8data = '';

		while ( $uchar = substr($ucs2data, $pos, 2) )
		{
			$utf8data .= ucs2c_2_utf8c( ord($uchar{1})*0x0100 + ord($uchar{0}) );
			$pos++;
			$pos++;
		}

		return $utf8data;

	} // end function ucs2le_2_utf8

	/**
	 * $str = ucs2le_2_armscii8($str);
	 */
	function ucs2le_2_armscii8($str)
	{
		return ucs2_2_armscii8($str);
	} // end function ucs2le_2_armscii8

	/**
	 * $str = ucs2le_2_armscii8($str);
	 */
	function ucs2le_2_html($str)
	{
		$result = '';
		$len = us_strlen($str);
		$ucodes = unpack('v'.$len, $str);

		foreach ($ucodes as $code)
		{
			if ($code < 0x80)
			{
				$result .= pack('C', $code);
			}
			elseif ( ($code > 0x9F) && ($code < 0x100) )
			{
				$result .= htmlentities(pack('C', $code));
			}
			else
			{
				$result .= '&#'.$code.';';
			}
		}
		return $result;
		//return $str;
	} // end function ucs2le_2_html

	////////////////////////////////////////////////////////////////////////////
	//
	//
	////////////////////////////////////////////////////////////////////////////

	/**
	 *
	 * Convert Unicode (UCS-2LE) char to UTF-8 char
	 */
	function ucs2c_2_utf8c($uchar)
	{

		if ( $uchar < 0x0080 )
		{
			$utf8char = pack('C', $uchar );
		}
		elseif ( $uchar < 0x0800 )
		{
			$utf8char = pack('C', (0xC0 + ( $uchar >> 6 ) ) );
			$utf8char .= pack('C', ( 0x80 + ( $uchar & 0x3F ) ) );
		}
		elseif ( $uchar < 0x10000 )
		{
			$utf8char = pack('C', ( 0xE0 + ( $uchar >> 12 ) ) );
            $utf8char .= pack('C', ( 0x80 + ( ( $uchar >> 6) & 0x3F ) ) );
            $utf8char .= pack('C', ( 0x80 + ( $uchar & 0x3F ) ) );
		}

		return $utf8char;

	} // end function ucs2c_2_utf8c

	define('UNI_LIB_INCLUDED', 'uni.lib.php');

?>