<?php
//
// +----------------------------------------------------------------------+
// | PHP Multi-Byte String Functions                                      |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003-2004 Hayk Chamyan <hayk@mail.ru>                  |
// +----------------------------------------------------------------------+
// | License: http://www.gnu.org/licenses/gpl.txt                         |
// +----------------------------------------------------------------------+
//
// $Header: unis.lib.php, 8, 10.03.2004 18:34:51, Hayk Chamyan$
//

	/**
	 *
	 * MB_ASCII
	 * MB_UCS2
	 * MB_UCS2LE
	 * MB_UCS2BE
	 * MB_UTF8
	 * MB_ARMSCII8
	 */
	function us_to_unicode($str, $from_encoding)
	{
		if ( ($from_encoding==MB_UCS2LE) || ($from_encoding==MB_UCS2LE) )
		{
			return $str;
		}

		switch ($from_encoding)
		{
			case MB_ASCII:
				$str = ascii_2_ucs2le($str);
				break;
			case MB_UCS2BE:
				$str = ucs2be_2_ucs2le($str);
				break;
			case MB_UTF8:
				$str = utf8_2_ucs2le($str);
				break;
			case MB_ARMSCII8:
				$str = armscii8_2_ucs2le($str);
				break;
		}
		return $str;
	} // end function us_to_unicode

	/**
	 * MB_ASCII
	 * MB_UCS2
	 * MB_UCS2LE
	 * MB_UCS2BE
	 * MB_UTF8
	 * MB_ARMSCII8
	 *
	 */
	function us_from_unicode($str, $to_encoding)
	{
		if ( ($to_encoding==MB_UCS2LE) || ($to_encoding==MB_UCS2) )
		{
			return $str;
		}

		switch ($to_encoding)
		{
			case MB_ASCII:
				$str = ucs2le_2_ascii($str);
				break;
			case MB_UCS2BE:
				$str = ucs2le_2_ucs2be($str);
				break;
			case MB_UTF8:
				$str = ucs2le_2_utf8($str);
				break;
			case MB_ARMSCII8:
				$str = ucs2le_2_armscii8($str);
				break;
			case MB_HTML:
			case MB_HTML_ENTITIES:
				$str = ucs2le_2_html($str);
				break;
		}
		return $str;
	} // end function us_from_unicode

	/**
	 *
	 */
	function us_strlen($str)
	{
		return ( intval( strlen($str)/2 ) );
	} // end function us_strlen

	/**
	 *
	 */
	function us_strpos($haystack, $needle, $offset=NULL)
	{
		$result = strpos($haystack, $needle, $offset);
		if ($result)
		{
			return ( intval( $result/2 ) );
		}
		else
		{
			return ( $result );
		}

	} // end function us_strpos

	/**
	 *
	 * $needle - ia aieuoa iaiiai neiaiea
	 * $needle - 
	 */
	function us_strrpos($haystack, $needle)
	{
		$offset = FALSE;
		$res = FALSE;
		while ( $res = strpos($haystack, $needle, $offset) )
		{
			if ( ($res) && ($res > $offset) )
			{
				$offset = $res+2;
			}
			else
			{
				$offset = $res;
			}
		}

		if ($offset)
		{
			$result =  intval( ($offset-2)/2 );
		}
		else
		{
			$result = FALSE;
		}
		return $result;
	} // end function us_strrpos

	/**
	 *
	 */
	function us_substr($string, $start, $length=NULL)
	{
		if (!$length) $length = us_strlen($string);
		return substr($string, $start*2, $length*2);
	} // end function us_substr

	/**
	 * $string - unicode string
	 * return - unicode string
	 */
	function us_strtolower($string)
	{
		$result = '';

		$len = us_strlen($string);
		$unpack = sprintf('v%dcode', $len);
		$ucodes = unpack($unpack, $string);

		//   ? while?
		foreach ($ucodes as $code)
		{
			$result .= pack('v', uni_to_lower($code) );
		}

		return $result;
	} // end function us_strtolower

	/**
	 * $string - unicode string
	 * return - unicode string
	 */
	function us_strtoupper($string)
	{
		$result = '';

		$len = us_strlen($string);
		$unpack = sprintf('v%dcode', $len);
		$ucodes = unpack($unpack, $string);

		//   ? while?
		foreach ($ucodes as $code)
		{
			$result .= pack('v', uni_to_upper ($code) );
		}

		return $result;

	} // end function us_strtoupper


	/**
	 * substr_count ( string haystack, string needle)
	 */
	function us_substr_count($haystack, $needle)
	{
		return substr_count($haystack, $needle);
	} // end function us_substr_count

	define('UNIS_LIB_INCLUDED', 'unis.lib.php');

?>